* Ordered Outcome Chapter
drop _all

set obs 100
set seed 12345
gen double x1 = 3*uniform()+1
gen double x2 = 2*uniform()-1
gen double y = 1 + .5*x1 + 1.2*x2 + invnormal(uniform())
gen int ys = 1 if y <= 2.5
replace ys = 2 if y <= 3 & y > 2.5
replace ys = 3 if y <= 4 & y > 3
replace ys = 4 if y > 4

ologit ys x1 x2, nolog
aic
predict double (olpr1 olpr2 olpr3 olpr4), pr

oprobit ys x1 x2, nolog
aic
predict double (oppr1 oppr2 oppr3 oppr4), pr

oglm ys x1 x2, link(cloglog) nolog
aic
predict double (ocpr1 ocpr2 ocpr3 ocpr4), pr

oglm ys x1 x2, link(loglog) nolog
aic
predict double (ozpr1 ozpr2 ozpr3 ozpr4), pr

gologit2 ys x1 x2, nolog
aic

test [1=2], notest
test [1=3], accumulate

list ys olpr1 oppr1 ocpr1 ozpr1 in 55/62

list ys olpr2 oppr2 ocpr2 ozpr2 in 55/62

list ys olpr3 oppr3 ocpr3 ozpr3 in 55/62

list ys olpr4 oppr4 ocpr4 ozpr4 in 55/62

sysuse auto, clear
replace rep78=3 if rep78<=3
drop if rep78==.
label define replab 3 "poor-avg" 4 "good" 5 "best"
label values rep replab
tab rep78

ologit rep78 foreign length displacement, nolog
aic

oprobit rep78 foreign length displacement, nolog
aic

gologit2 rep78 foreign length displacement
aic

test [poor-avg=good]

gologit2 rep78 foreign length displacement, link(logit) eform nolog

gologit2 rep78 foreign length displacement, link(probit) nolog
aic

gologit2 rep78 foreign length displacement, link(cloglog) nolog
aic
display exp(2.334334)  /* Exponentiated coefficient for Poor-Average foreign */
gologit2 rep78 foreign length displacement, link(loglog) nolog
aic
display exp(2.659394)  /* Exponentiated coefficient for Poor-Average foreign */

set more off
sysuse auto, clear
generate headsize = int(headroom+.5)
replace headsize = 4 if headsize==5
tab headsize

ologit headsize foreign mpg price displacement, nolog
brant

brant, detail

gologit2 headsize foreign mpg price displacement

gologit2 headsize foreign mpg price displacement, autofit lrforce

gologit2 headsize foreign mpg price displacement, npl(foreign)

use edreligion, clear
tab educlevel

ologit educlevel religious kids age male, nolog
aic

brant, detail

gologit2 educlevel religious kids age male, autofit lrforce nolog
aic

ocratio educlevel religious kids age male, link(logit)
aic

display "AIC Statistic = " (-2*(-605.4009+4)/997)

ocratio educlevel religious kids age male, link(logit) eform
aic
